program fsprites;

{
        Fast Sprites
        ============

     by Yzi/Fit July 1994

       thanx to Marq!


   _FAST_ sprite routines, based on the marvellous idea of making
    a procedure without loops by making separate code for every
    single pixel! Think about how much faster it is to put immediate
    values to vram instead of reading and writing and looping...


  These opcodes are used in the routine:

   command                              | opcode
  --------------------------------------+----------------------
   ES:                                  | 26
   MOV     BYTE PTR [DI], IMMEDIATE     | C6 05 BYTE
   MOV     WORD PTR [DI], IMMEDIATE     | C7 05 LOBYTE HIBYTE
   INC     DI                           | 47
   ADD     DI, IMMEDIATE                | 81 C7 LOBYTE HIBYTE
   MOV     DI, CX                       | 89 CF
   MOV     DI, BX                       | 89 DF
   MOV     DI, SI                       | 89 F7
   ROL     AL, 1                        | D0 C0
   OUT     DX, AL                       | EE

}

 uses tweak, yscreen, readygp, trigi;

 const maxsprites = 7;
       xsze = 32;
       ysze = 30;
       askel = 360 div maxsprites;

 type plokki = array [0..65534] of byte;

 var sprite_proc : array [0..maxsprites-1] of pointer;
     w, w2, w3,
     fa, fa2, a, a2, sivu, sofs, _sofs, ringsize, ringdelay : word;
     dringsize : integer;
     s_x, _s_x, s_y, _s_y : array [0..maxsprites-1] of word;
     kuva : ^plokki;
     koko : longint;

 procedure far_call;
  assembler;
  asm
        db      $9a             {far call opcode}
        dw      $cbcb           {dword pointer}
        dw      $cbcb
  end; {far_jump}

 procedure putsprite (proc_ptr : pointer;
                      sx, sy, sseg : word);
  assembler;
  asm
        mov     ax, word ptr proc_ptr[0] {set the far call pointer}
        mov     word ptr far_call[1], ax
        mov     ax, word ptr proc_ptr[2]
        mov     word ptr far_call[3], ax

        mov     ax, 5           {add the y-coordinate to the address}
        mul     sy
        add     sseg, ax
        mov     es, sseg
        mov     di, sx          {es:di points to screen}

        mov     dx, $3c4        {prepare vga to receive plane masks}
        mov     al, 2
        out     dx, al
        inc     dx              {dx = $3c5}

        mov     cx, di          {set first plane mask}
        and     cx, 3
        mov     al, 1
        shl     al, cl
        out     dx, al

        mov     ah, al          {set mask in both al nibbles}
        shl     ah, 4
        add     al, ah

        mov     cx, di          {prepare the offsets for pages 1, 2 & 3}
        inc     cx              {di: page 0 (current)}
        mov     bx, cx          {cx: page 1}
        inc     bx              {bx: page 2}
        mov     si, bx          {si: page 3}
        inc     si
        shr     di, 2
        shr     cx, 2
        shr     bx, 2
        shr     si, 2

        call    far_call        {...ja eikun menoksi!}
  end; {putsprite}

 procedure clearsprite (seg0, seg1, ofs1, xsize, ysize : word);
  assembler;
  asm
        push    ds
        cld
        mov     ds, seg0
        mov     si, ofs1
        mov     es, seg1
        mov     di, si

        mov     dx, $3c4        {mask all planes}
        mov     ax, $f02
        out     dx, ax

        shr     xsize, 2
        inc     xsize
        mov     ax, 80
        sub     ax, xsize
        mov     bx, ysize
@yl:    {mov     cx, xsize}
        movsb
        movsb
        movsb
        movsb
        movsb
        movsb
        movsb
        movsb
        movsb
        add     di, ax
        add     si, ax
        dec     bx
        jnz     @yl

        pop     ds
  end; {clearsprite}

 var code : array [0..32768] of byte;

 function make_sprite (var sproc_ptr : pointer;
                       dataseg, dataofs, xsize, ysize : word) : word;
  {Use this after calling take_sprite to prepare the procedure
   pointed by sproc_ptr.}
  var page, ero, i, i2 : integer;
      dseg, dofs, codecnt, riviero : word;
      curb : byte;
  procedure putcode (pcb : byte);
   begin
    code[codecnt] := pcb; inc (codecnt);
   end; {putcode}

  begin
   dseg := dataseg;
   codecnt := 0;
   riviero := 320-xsize;
   for page := 0 to 3 do
    begin
     ero := 0;
     dofs := dataofs + page;
     for i := 1 to ysize do
      begin
       for i2 := 1 to (xsize shr 2) do
        begin
         curb := mem[dseg:dofs];
         if curb > 0 then
          begin
           if ero > 0 then
            if ero = 1 then
             putcode ($47) { inc di }
            else
             begin {add di, ero}
              putcode ($81); putcode ($c7);
              putcode (lo(ero)); putcode (hi(ero));
             end;
           putcode ($26); {es:}
           putcode ($c6); putcode ($05); putcode (curb); {mov [di], curb}
           ero := 0;
          end; {curb > 0}
         inc (dofs, 4);
         inc (ero);
        end; {for vaakaan}
       inc (ero, riviero shr 2);
       inc (dofs, riviero);
      end; {for pystyyn}
     if page < 3 then putcode ($89); {mov di, ...}
     case page of
      0 : putcode ($cf); {mov di, cx}
      1 : putcode ($df); {mov di, bx}
      2 : putcode ($f7); {mov di, si}
     end; {case page}
     if page < 3 then
      begin
       putcode ($d0); putcode ($c0); {rol al, 1}
       putcode ($ee); {out dx, al}
      end;
    end; {for page}
   putcode ($cb); {far ret}
   getmem (sproc_ptr, codecnt);
   move (code[0], sproc_ptr^, codecnt);
   make_sprite := codecnt;
  end; {make_sprite}

 procedure putpic (s1, o1, s2, o2 : word);
  assembler;
  asm
        cld
        mov     ax, s1
        mov     si, o1
        push    ds
        mov     ds, ax
        mov     ax, s2
        mov     es, ax
        mov     di, o2
        mov     dx, $3c4
        mov     al, 2
        out     dx, al
        inc     dx
        mov     cx, 4
 @PL:
        mov     al, 16
        shr     al, cl
        out     dx, al
        push    cx
        push    si
        push    di
        mov     cx, 200
 @L2:
        push    cx
        mov     cx, 80
 @L:
        movsb
        add     si, 3
        loop    @L
        pop     cx
        loop    @L2
        pop     di
        pop     si
        inc     si
        pop     cx
        loop    @PL
        pop     ds
  end; {putpic}

 procedure abort (astr : string);
  begin
   setgraphicsmode (3);
   writeln (astr);
   halt;
  end; {abort}

begin
 tweak_setmode (4);
 qscreenoff;
 getmem (kuva, 64000);
 if not yg_loadygp ('norsu.ygp', kuva, addr(bpal)) then
  abort ('Cannot load piccy!');
 putpic (seg(kuva^), ofs(kuva^), $a000, 0);
 putpic (seg(kuva^), ofs(kuva^), $a000, 16000);
 putpic (seg(kuva^), ofs(kuva^), $a000, 16000*2);
 putpic (seg(kuva^), ofs(kuva^), $a000, 16000*3);
 fastsetpal (seg(bpal), ofs(bpal));
 if not yg_loadygp ('bl32.ygp', kuva, addr(bpal)) then
  abort ('Cannot load piccy 2!');
 trigi_kerroin := 99-ysze div 2;
 buildsini;
 trigi_kerroin := 159-xsze div 2;
 buildcosi;

 a := 0; a2 := 21; fa := 0; fa2 := 0;
 for w := 0 to maxsprites-1 do
  begin s_x[w] := 0; s_y[w] := 0; _s_x[w] := 0; _s_y[w] := 0; end;
 ringsize := 4;
 dringsize := 1;

 koko := 0;
 for w := 0 to maxsprites-1 do
  koko := koko + make_sprite (sprite_proc[w],
                       seg(kuva^)+20*3*32+20, ofs(kuva^)+3*32+w*32,
                       xsze, ysze);
 ringdelay := 10;
 sivu := 0;
 sofs := 0;
 qscreenon;
 repeat
  brsync;
  setc (0, 0, 0, 0);
  sivu := 200*5-sivu;
  setwritemode (1);
  for w := 0 to maxsprites - 1 do
   begin
    w2 := _s_y[w]*5;
    if (_sofs+w2 >= 170*5) then
     begin
      if _sofs+w2 >= 200*5 then
       clearsprite ($a000+w2+_sofs+400*5,
                    $a000+sivu+w2+_sofs,
                    _s_x[w] shr 2, xsze, ysze)
      else
       begin
        w3 := 200-(_sofs div 5 + _s_y[w]);
        clearsprite ($a000+w2+_sofs+600*5,
                     $a000+sivu+w2+_sofs,
                     _s_x[w] shr 2, xsze, w3);
        clearsprite ($a000+w2+_sofs+400*5+w3*5,
                     $a000+sivu+w2+_sofs+w3*5,
                     _s_x[w] shr 2, xsze, 32-w3);
       end
     end
    else
     clearsprite ($a000+5*600+(w2+_sofs),
                  $a000+sivu+w2+_sofs,
                  _s_x[w] shr 2, xsze, ysze);
    _s_x[w] := s_x[w];
    _s_y[w] := s_y[w];
   end;
  setwritemode (0);
  _sofs := sofs;

  dec (sofs, 5);
  if (sofs > 200*5) then sofs := 199*5;

  a := (a + 3) mod 360;
  a2 := (a2 + 2) mod 360;
  dec (ringdelay);
  if ringdelay <= 0 then
   begin
    ringdelay := 10;
    inc (ringsize, dringsize);
    if (ringsize <= 1) or (ringsize >= 128) then dringsize := -dringsize;
    if ringsize >= 128 then ringdelay := 65;
   end;
  for w := 0 to maxsprites - 1 do
   begin
    s_x[w] := cosi[(a+w*askel)mod 360]*ringsize shr 7  + 160 - xsze div 2;
    s_y[w] := sini[(a2+w*askel)mod 360]*ringsize shr 7 + 100 - ysze div 2;
    putsprite (sprite_proc[w], s_x[w],
               s_y[w], $a000+sivu+sofs);
   end;
  asm
        mov     dx, $3da
  @wvr: in      al, dx
        test    al, 8
        jnz     @wvr
  end;
  putscreen ((sivu + sofs) shl 4);
  setc (0, 30, 0, 0);
 until port[$60] < $80;
 setgraphicsmode (3);
 writeln ('Average sprite code size: ', koko div maxsprites);
end.